program omenup;
{ Dropdown menu system in graphics
  copyright 1993, and written by
             Jay Faubion,
             Binary International Marketing
             139 Eastern Avenue
             Plainfield, IN  46168
             Compuserve 72763,200
}
{$A+     + Align Data on}
{$B-     - Boolean Eval short}
{$D+     + Debug info on}
{$E+     + 8087 Emulation on}
{$F+     + Force far calls on}
{$G+     + Generate 286 code}
{$I+     + IO checking on}
{$L+     + Local symbols on}
{$N-     - Numeric Processing off}
{$O-     - Overlays off}
{$R+     + Range checks on}
{$S+     + Stack checks on}
{$V-     - Relaxed String checks}
{$X+     + Extended Syntax on}

uses crt,omenu;
  const
    Version = 1.01;                  { minor cleanup from previous release }
  var
    HVMenu           : OHVMenu;      { OHVMenu is Horiz-Vert Menu obj }
                     {     *** This is the combined menu object ! *** }
    AStr             : string;
    i,j,k,x          : integer;
    c                : char;
    NBg              : integer;      { Normal Background color }
    NFg              : integer;      { Normal Foreground color }
    HBg              : integer;      { Highlighted Background color }
    HFg              : integer;      { Highlighted Foreground color }
    BC               : integer;      { Border color }
    SC               : integer;      { Shadow color }
begin
    NBg              := blue ;
    NFg              := white;
    HBg              := white;
    HFg              := blue ;
    BC               := black;
    SC               := gray;

  GraphInit;                              { Initialize graphics }
  GClrScr(black);                          { Clear crt to a specific color }
  for i := 0 to 21 do GWriteXy(0,i,
    'We are in graphics mode displaying text across the screen.',black,white);

  HVMenu.init;                            { Initialize the menu object}
  {Horizontal Menu bar parameters go here...}
  HVMenu.SetHorItems(  00,00,80,01,       {x1,y1,x2,y2 coordinates}
                       NBg,               {Normal Background}
                       NFg,               {Normal Foreground}
                       HBg,               {Highlighted Background}
                       HFg,               {Highlighted Foreground}
                       BC,                {Border Color}
                       SC,                {Shadow Color (white looks black)}
                       1,                 {Item to highlight first}
                       BorderOn,          {Draw border? BorderOn,BorderOff}
                       ShadowOff,         {Shadow on? ShadowOn,ShadowOff}
                       ' File | Edit | Utility | Preferences ');
                                          {Menu items, delimited with '|'}
                       { Horizontal menu does not require *menu number* parm}

  {Vertical Menu parameters go here...}
  HVMenu.SetVerItems(  01,                {Vertical Menu Number}
                       00,01,10,          {x1,y1,x2 coordinates}
                                          {vert menu does not require Y2 parm}
                       NBg,               {Normal Background}
                       NFg,               {Normal Foreground}
                       HBg,               {Highlighted Background}
                       HFg,               {Highlighted Foreground}
                       BC,                {Border Color}
                       SC,                {Shadow Color (white looks black)}
                       1,                 {Item to highlight first}
                       BorderOn,          {Draw border? BorderOn,BorderOff}
                       ShadowOn,          {Shadow on? ShadowOn,ShadowOff}
                       ' Save | Save As | Print | Quit ');
                                          {Menu items, delimited with '|'}

  HVMenu.SetVerItems(2,06,01,17,NBg,NFg,HBg,HFg,BC,Sc,
                     1,BorderOn,ShadowOn,
                     ' Change | Restore ');
  HVmenu.SetVerItems(3,12,01,29,NBg,NFg,HBg,HFg,BC,Sc,
                     1,BorderOn,ShadowOn,
                     ' Some options | No Options | A New Option | An Old Option | Something Borrowed | Something Blue ');
  HVMenu.SetVerItems(4,21,01,39,NBg,NFg,HBg,HFg,BC,Sc,
                     1,BorderOn,ShadowOn,
                     ' Save Screen | Font | Whatever ');

  X:=HVMenu.MenuResult(false,true);
  str(x div 100,AStr);
  GWritexy(0,22,'Horizontal Choice was '+AStr,white,black);
  str(x mod 100,AStr);
  GWritexy(0,23,'Vertical Choice was '+AStr,white,black);
  str(x,AStr);
  GWritexy(0,24,'Hor-Vert Choice was '+AStr,white,black);
  c:=readkey;

  {At this point you take action on the user's response to the menu...
    if x=101 do something (option 1, sub-option 1)
    if x=102 do something else (option 1, sub-option 2)
    if x=305 do the other thing (option 3, sub-option 5)
    if x mod 100=0 then he wants to quit (pushed escape)
  }
  HVMenu.Done;    { Finished with the menu objects }
  GraphDone;      { out of graphics, back to text mode }

  end.
